<?php

namespace Drupal\Tests\jsnlog\Functional;

use Drupal\Core\Url;
use Drupal\Tests\BrowserTestBase;
use Drupal\jsnlog\Form\JSNLogSettingsForm;

/**
 * Test jsnlog settings form.
 * 
 * @group jsnlog
 */
class JsnlogSettingsFormTest extends BrowserTestBase {


  /**
   * Modules to enable.
   *
   * @var array
   */
  public static $modules = ['jsnlog'];

  /**
   * A simple user.
   *
   * @var \Drupal\user\Entity\User
   */
  private $user;

  /**
   * {@inheritdoc}
   */
  protected function setUp() {
    parent::setup();
    $this->user = $this->drupalCreateUser(['administer jsnlog']);
  }

  public function testBuildForm() {
    $this->drupalLogin($this->user);
    $assertion = $this->assertSession();

    // Routes with menu links, and their form buttons.
    $routes = [
      'jsnlog.settings.form' => ['Save configuration'],
    ];

    // Go to all the routes and click all the buttons.
    foreach ($routes as $route => $buttons) {
      $path = Url::fromRoute($route);
      error_log($route);
      $this->drupalGet($path);

      $assertion->statusCodeEquals(200);
      foreach ($buttons as $button) {
        $this->drupalPostForm($path, [], $button);
        $assertion->statusCodeEquals(200);
      }
    }
  }

}
