<?php

namespace Drupal\Tests\jsnlog\FunctionalJavascript;

use Drupal\FunctionalJavascriptTests\WebDriverTestBase;
use Drupal\Core\Url;

/**
 * JavaScript tests.
 *
 * @ingroup jsnlog
 *
 * @group jsnlog
 */
class JsnlogJsTest extends WebDriverTestBase {

  /**
   * Modules to enable.
   *
   * @var array
   */
  public static $modules = ['jsnlog'];

  /**
   * A user with permission to administer site configuration.
   *
   * @var \Drupal\user\UserInterface
   */
  protected $adminUser;

  /**
   * {@inheritdoc}
   */
  protected function setUp() {
    parent::setUp();
  }

  /**
   * Tests that the home page loads with a 200 response.
   */
  public function testFrontpage() {
    $this->drupalGet(Url::fromRoute('<front>'));
    $page = $this->getSession()->getPage();

    $this->assertJsCondition('typeof(JL) == \'function\'');

    $this->assertJsCondition('typeof(JL().error(\'This is a test error.\')) == \'object\'');
    $this->assertSession()->assertWaitOnAjaxRequest(100);
  }

}
